"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
function getTextFromFormattingEdits(sourceFile, formattingEdits) {
    var e_1, _a;
    // reverse the order
    var reversedFormattingEdits = formattingEdits.map(function (edit, index) { return ({ edit: edit, index: index }); }).sort(function (a, b) {
        var aStart = a.edit.getSpan().getStart();
        var bStart = b.edit.getSpan().getStart();
        var difference = bStart - aStart;
        if (difference === 0)
            return a.index < b.index ? 1 : -1;
        return difference > 0 ? 1 : -1;
    });
    var text = sourceFile.getFullText();
    try {
        for (var reversedFormattingEdits_1 = tslib_1.__values(reversedFormattingEdits), reversedFormattingEdits_1_1 = reversedFormattingEdits_1.next(); !reversedFormattingEdits_1_1.done; reversedFormattingEdits_1_1 = reversedFormattingEdits_1.next()) {
            var edit = reversedFormattingEdits_1_1.value.edit;
            var span = edit.getSpan();
            text = text.slice(0, span.getStart()) + edit.getNewText() + text.slice(span.getEnd());
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (reversedFormattingEdits_1_1 && !reversedFormattingEdits_1_1.done && (_a = reversedFormattingEdits_1.return)) _a.call(reversedFormattingEdits_1);
        }
        finally { if (e_1) throw e_1.error; }
    }
    return text;
}
exports.getTextFromFormattingEdits = getTextFromFormattingEdits;
